

/**********************************************************/

// Déclaration des branchements
int Belier_D =6;          // Permet de commander le Belier en monté
int Belier_M =7;          // Permet de commander le Belier en  descente
int Capteur_Dechets = A0; // Permet de detecter que la hauteur max des dechets est atteinte
int LED_2=13;             // LED qui permet de signaler que le compacteur est plein
int LED_1=12;             // LED qui permet de signaler que le système attend des déchets ou que le belier est en mouvement
int LED_3=11;             // LED qui permet de signaler que le compacteur est presque plein
const byte Codeur = 2;    // Codeur qui détecte que le belier est en mouvement
const byte I_Max = A5;    // Mesure du courant moteur

// Déclaration des variables

int Capt_Dech=0;          // Variable correspondant à l'état du capteur de déchet
int Nombre_Impulsions=0;  // Variable qui correspond au déplacement du bélier
int Distance=22;          // Variable qui correspond à la course maximale du bélier
int N_Imax=0;             // Variable qui correspond au courant moteur
int N_Compactage=0;       // Variable qui correspond au nombre de compactage

// Programme d'initialisation
void setup() 
{
  pinMode(Belier_D, OUTPUT);        // Déclaration des broches comme étant des Sories 
  pinMode(Belier_M, OUTPUT);
  pinMode(LED_1,OUTPUT);digitalWrite (LED_1,HIGH); 
  pinMode(LED_2,OUTPUT);digitalWrite (LED_2,HIGH); 
  pinMode(LED_3,OUTPUT);digitalWrite (LED_3,HIGH); 
  
  pinMode(Capteur_Dechets, INPUT);  // Déclaration des broches comme étant des Entrées
  pinMode(I_Max, INPUT);            // Déclaration des broches comme étant des Entrées
  
  Serial.begin(9600); 

  attachInterrupt(digitalPinToInterrupt(Codeur),Compteur_Impulsions, RISING);// Autorisation interruption sur fronts montants du codeur
}
  
/*********************************************************/
void loop()                               // début du programme principal
{

Capt_Dech = analogRead(Capteur_Dechets);  // Lecture du capteur de déchets

while(Capt_Dech < 512 )                   // Tant que capteur de déchet n'est pas activé
{
  noInterrupts();
  digitalWrite (Belier_D,LOW);            // Moteur off
  digitalWrite (Belier_M,LOW);
  
  digitalWrite (LED_1,LOW);               // Led verte Clignotante
  delay(500);
  digitalWrite (LED_1,HIGH);               
  delay(500);
  
  Capt_Dech = analogRead(Capteur_Dechets);// Lecture du capteur de déchets
  Distance=22;                            // Initialisation des variables
  Nombre_Impulsions=0;                    // 
  N_Imax=analogRead(I_Max);               // Lecture du courant moteur
  Nombre_compactage();                    // Appel du sous programme Nombre_compactage 
   }
  
  while((Nombre_Impulsions < Distance )&&(N_Imax<270)) // Tant que le bélier n'est pas tout en bas et que
  {                                                    // le courant moteur n'est pas au maxi
  interrupts();                                        // Permet de compter les impulsions du codeur
  digitalWrite (LED_1,LOW);                            // Led verte on
  digitalWrite (Belier_D,HIGH);                        // descente du bélier
  digitalWrite (Belier_M,LOW);                                                 
  delay(1500);
  N_Imax=analogRead(I_Max);                            // Lecture du courant moteur
  }
  
  N_Compactage=N_Compactage+1;                         // Compter le nombre de compactages
  Distance=Nombre_Impulsions;                          // mémorise le déplacement du bélier
  Nombre_Impulsions=0;                                 // Initialise le nombre d'impulsions du codeur à 0
  
  while (Nombre_Impulsions<Distance)                   // Tant que le bélier n'a pas retrouvé sa position haute
  {
  interrupts();                                        // Permet de compter les impulsions du codeur
  digitalWrite (Belier_D,LOW);                         // Monté du bélier
  digitalWrite (Belier_M,HIGH);                        // Monté du bélier
  }

 
}

void Nombre_compactage()                              // Sous programme permettant de gérer l'affichage
{                                                     // en fonction du nombre de compactages
  
if (N_Compactage>2)
{
  digitalWrite (LED_3,LOW);
}
if (N_Compactage==5)
{
  while(1)
  {
  digitalWrite (LED_2,LOW);
  digitalWrite (LED_3,HIGH);
  delay(1000);
  digitalWrite (LED_2,HIGH);
  delay(1000);
  }
}  
  
}

void Compteur_Impulsions()                            // Programme executé lorsque l'interuption INT0 est activée
{
  Nombre_Impulsions= Nombre_Impulsions + 1 ;          // Comptage du nombre d'impulsions du codeur
}
